%define name	elfutils
%define version	0.120
%define release	%mkrel 2

%define major	1
%define libname	%mklibname %{name} %{major}

%define _gnu	%{nil}
%define _program_prefix eu-

%ifarch %{sunsparc}
%define	build_check		0
%else
%define build_check		1
%endif
%{expand: %{?_without_CHECK:	%%global build_check 0}}
%{expand: %{?_with_CHECK:	%%global build_check 1}}

%define build_compat		0
%if %{mdkversion} < 1010
%define build_compat		1
%endif
%{expand: %{?_without_COMPAT:	%%global build_compat 0}}
%{expand: %{?_with_COMPAT:	%%global build_compat 1}}

Summary:	A collection of utilities and DSOs to handle compiled objects
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		Development/Other
Source0:	elfutils-%{version}.tar.bz2
Patch0:		elfutils-0.118-portability.patch.bz2
Patch1:		elfutils-0.120-robustify.patch.bz2
Patch2:		elfutils-0.120-fix-sparc-build.patch.bz2
Requires:	%{libname} = %{version}-%{release}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
%if %{build_compat}
BuildRequires:	gcc >= 3.2
%else
BuildRequires:	gcc >= 3.4
%endif
BuildRequires:	sharutils
BuildRequires:	libtool-devel

%description
Elfutils is a collection of utilities, including:

   * %{_program_prefix}nm: for listing symbols from object files
   * %{_program_prefix}size: for listing the section sizes of an object or archive file
   * %{_program_prefix}strip: for discarding symbols
   * %{_program_prefix}readelf: the see the raw ELF file structures
   * %{_program_prefix}elflint: to check for well-formed ELF files

%package -n	%{libname}-devel
Summary:	Development libraries to handle compiled objects
Group:		Development/Other
License:	GPL
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel lib%{name}-devel
Obsoletes:	libelf-devel libelf0-devel
Provides:	libelf-devel libelf0-devel

%description -n	%{libname}-devel
This package contains the headers and dynamic libraries to create
applications for handling compiled objects.

   * libelf allows you to access the internals of the ELF object file
     format, so you can see the different sections of an ELF file.
   * libebl provides some higher-level ELF access functionality.
   * libasm provides a programmable assembler interface.

%package -n	%{libname}-static-devel
Summary:	Static libraries for development with libelfutils
Group:		Development/Other
License:	GPL
Requires:	%{libname}-devel = %{version}-%{release}
Provides:	%{name}-static-devel lib%{name}-static-devel
Obsoletes:	libelf-static-devel libelf0-static-devel
Provides:	libelf-static-devel libelf0-static-devel

%description -n	%{libname}-static-devel
This package contains the static libraries to create applications for
handling compiled objects.

%package -n	%{libname}
Summary:	Libraries to read and write ELF files
Group:		System/Libraries
License:	OSL
Provides:	lib%{name}
Obsoletes:	libelf libelf0
Provides:	libelf libelf0

%description -n	%{libname}
This package provides DSOs which allow reading and writing ELF files
on a high level.  Third party programs depend on this package to read
internals of ELF files.  The programs of the elfutils package use it
also to generate new ELF files.

Also included are numerous helper libraries which implement DWARF,
ELF, and machine-specific ELF handling.

%prep
%setup -q
%if %{build_compat}
%patch0 -p1 -b .portability
sleep 1
find . \( -name Makefile.in -o -name aclocal.m4 \) -print | xargs touch
sleep 1
find . \( -name configure -o -name config.h.in \) -print | xargs touch
%endif
# Don't use -Werror with -Wformat=2 -std=gnu99 as %a[ won't be caught
# as the GNU %a extension.
perl -pi -e '/AM_CFLAGS =/ and s/-Werror//g' ./tests/Makefile.{in,am}
%patch1 -p1 -b .robustify
%patch2 -p1 -b .sparc

%build
mkdir build-%{_target_platform}
pushd build-%{_target_platform}
CONFIGURE_TOP=.. \
%ifarch %{sunsparc}
CFLAGS="$RPM_OPT_FLAGS -Wno-error" \
%endif
%configure2_5x \
%{?_program_prefix: --program-prefix=%{_program_prefix}} --enable-shared
%make
popd

%check
%if %{build_check}
pushd build-%{_target_platform}
#%make check
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_prefix}

%makeinstall_std -C build-%{_target_platform}

chmod +x $RPM_BUILD_ROOT%{_libdir}/lib*.so*
chmod +x $RPM_BUILD_ROOT%{_libdir}/elfutils/lib*.so*

# XXX Nuke unpackaged files
{ cd $RPM_BUILD_ROOT
  rm -f .%{_bindir}/eu-ld
  rm -f .%{_bindir}/eu-objdump
  rm -f .%{_includedir}/elfutils/libasm.h
  rm -f .%{_libdir}/libasm-%{version}.so
  rm -f .%{_libdir}/libasm.{a,so}
}

%clean
rm -rf $RPM_BUILD_ROOT

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc NOTES README NEWS TODO
%{_bindir}/eu-addr2line
%{_bindir}/eu-elfcmp
%{_bindir}/eu-findtextrel
%{_bindir}/eu-elflint
#%{_bindir}/eu-ld
%{_bindir}/eu-nm
%{_bindir}/eu-ranlib
%{_bindir}/eu-readelf
%{_bindir}/eu-size
%{_bindir}/eu-strip
%{_bindir}/eu-strings
%{_libdir}/libdw-%{version}.so
%{_libdir}/libdw*.so.*
%dir %{_libdir}/elfutils
%{_libdir}/elfutils/lib*.so

%files -n %{libname}-devel
%defattr(-,root,root)
%{_includedir}/dwarf.h
%{_includedir}/libelf.h
%{_includedir}/gelf.h
%{_includedir}/nlist.h
%dir %{_includedir}/elfutils
%{_includedir}/elfutils/elf-knowledge.h
%{_includedir}/elfutils/libebl.h
%{_includedir}/elfutils/libdw.h
%{_includedir}/elfutils/libdwfl.h
#%{_libdir}/libasm.so
#%{_libdir}/libdwarf.so
#%{_libdir}/libebl.so
%{_libdir}/libelf.so
%{_libdir}/libdw.so

%files -n %{libname}-static-devel
%defattr(-,root,root)
#%{_libdir}/libasm.a
%{_libdir}/libebl.a
%{_libdir}/libelf.a
%{_libdir}/libdw.a

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/libelf-%{version}.so
%{_libdir}/libelf*.so.*
#%{_libdir}/libasm-%{version}.so
#%{_libdir}/libasm*.so.*
#%{_libdir}/libebl-%{version}.so
#%{_libdir}/libebl*.so.*

%changelog
* Sun May 14 2006 Stefan van der Eijk <stefan@eijk.nu> 0.120-2mdk
- rebuild for sparc

* Tue Apr 18 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.120-1mdk
- 0.120
- update robustification patch (P1)
- fix sparc build (P2)
- License has been changed to GPL, except for libraries which is still OSL
- move check to %%check stage
- disable checks on sparc

* Wed Apr 05 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.119-2mdk
- add robustification patch (P1) from fedora
- don't give errors on compile warnings on sparc

* Fri Jan 27 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.119-1mdk
- 0.119
- %%mkrel

* Wed Dec 28 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.118-1mdk
- 0.118

* Tue Jul 26 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.109-1mdk
- 0.109

* Thu Feb 17 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.99-1mdk
- 0.99

* Sun Jan 23 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.97-1mdk
- 0.97
- fix summary-ended-with-dot

* Fri Sep 17 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.96-1mdk
- 0.96

* Mon Jan 26 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.89-3mdk
- fix unpackaged files

* Tue Nov 18 2003 Stefan van der Eijk <stefan@eijk.nu> 0.89-2mdk
- atime alpha patch, obtained from gentoo, bug #27372

* Wed Nov  5 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.89-1mdk
- 0.89, some -Werror fixlets

* Fri Jul 25 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.84-1mdk
- 0.84

* Wed Jul 16 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.83-1mdk
- 0.83

* Tue Jul  8 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.80-1mdk
- 0.80

* Tue Jul 08 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 0.79-2mdk
- rebuild for new provides

* Tue Jun  3 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.79-1mdk
- 0.79
- -static-devel'ize

* Thu Apr  3 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.76-1mdk
- 0.76

* Fri Dec 20 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.72-3mdk
- First Mandrake Linux release adapted from Red Hat package
- BuildRequires: libtool-devel

* Thu Dec 12 2002 Jakub Jelinek <jakub@redhat.com> 0.72-2
- update to 0.72

* Wed Dec 11 2002 Jakub Jelinek <jakub@redhat.com> 0.71-2
- update to 0.71

* Wed Dec 11 2002 Jeff Johnson <jbj@redhat.com> 0.69-4
- update to 0.69.
- add "make check" and segfault avoidance patch.
- elfutils-libelf needs to run ldconfig.

* Tue Dec 10 2002 Jeff Johnson <jbj@redhat.com> 0.68-2
- update to 0.68.

* Fri Dec  6 2002 Jeff Johnson <jbj@redhat.com> 0.67-2
- update to 0.67.

* Tue Dec  3 2002 Jeff Johnson <jbj@redhat.com> 0.65-2
- update to 0.65.

* Mon Dec  2 2002 Jeff Johnson <jbj@redhat.com> 0.64-2
- update to 0.64.

* Sun Dec 1 2002 Ulrich Drepper <drepper@redhat.com> 0.64
- split packages further into elfutils-libelf

* Sat Nov 30 2002 Jeff Johnson <jbj@redhat.com> 0.63-2
- update to 0.63.

* Fri Nov 29 2002 Ulrich Drepper <drepper@redhat.com> 0.62
- Adjust for dropping libtool

* Sun Nov 24 2002 Jeff Johnson <jbj@redhat.com> 0.59-2
- update to 0.59

* Thu Nov 14 2002 Jeff Johnson <jbj@redhat.com> 0.56-2
- update to 0.56

* Thu Nov  7 2002 Jeff Johnson <jbj@redhat.com> 0.54-2
- update to 0.54

* Sun Oct 27 2002 Jeff Johnson <jbj@redhat.com> 0.53-2
- update to 0.53
- drop x86_64 hack, ICE fixed in gcc-3.2-11.

* Sat Oct 26 2002 Jeff Johnson <jbj@redhat.com> 0.52-3
- get beehive to punch a rhpkg generated package.

* Wed Oct 23 2002 Jeff Johnson <jbj@redhat.com> 0.52-2
- build in 8.0.1.
- x86_64: avoid gcc-3.2 ICE on x86_64 for now.

* Tue Oct 22 2002 Ulrich Drepper <drepper@redhat.com> 0.52
- Add libelf-devel to conflicts for elfutils-devel

* Mon Oct 21 2002 Ulrich Drepper <drepper@redhat.com> 0.50
- Split into runtime and devel package

* Fri Oct 18 2002 Ulrich Drepper <drepper@redhat.com> 0.49
- integrate into official sources

* Wed Oct 16 2002 Jeff Johnson <jbj@redhat.com> 0.46-1
- Swaddle.
